Subject: [quicwg/base-drafts] RTTVar is not really a variance (#3223)

From: ianswett <[email-masked]>
Date: Mon, 11 Nov 2019 16:19:29 -0800

It&#39;s a mean deviation.  This has confused at least one reader.
You can view, comment on, or merge this pull request online at:

  https://github.com/quicwg/base-drafts/pull/3223

-- Commit Summary --

  * RTTVar is not really a variance

-- File Changes --

    M draft-ietf-quic-recovery.md (13)

-- Patch Links --

https://github.com/quicwg/base-drafts/pull/3223.patch
https://github.com/quicwg/base-drafts/pull/3223.diff

-- 
You are receiving this because you are subscribed to this thread.
Reply to this email directly or view it on GitHub:
https://github.com/quicwg/base-drafts/pull/3223

---

From: Martin Thomson <[email-masked]>
Date: Mon, 11 Nov 2019 16:26:25 -0800

True-ish, but nor is smoothed_rtt a mean.  And now you have a variable with a name that bears no semblance to the concept you use to describe it.  You could instead play apologist and explain that this isn't a variance in the statistical sense, but variance in a purely colloquial sense.

-- 
You are receiving this because you are subscribed to this thread.
Reply to this email directly or view it on GitHub:
https://github.com/quicwg/base-drafts/pull/3223#issuecomment-552678576

---

From: ianswett <[email-masked]>
Date: Mon, 11 Nov 2019 16:31:21 -0800

Section 2 of RFC2988 says
"To compute the current RTO, a TCP sender maintains two state
   variables, SRTT (smoothed round-trip time) and RTTVAR (round-trip
   time variation)."

It does subsequently use the term variance in one spot, but given the original definition is a better one, I'd rather use variation than variance.

RFC6298 does the exact same thing, and defines RTTVAR as "round-trip time variation".

-- 
You are receiving this because you are subscribed to this thread.
Reply to this email directly or view it on GitHub:
https://github.com/quicwg/base-drafts/pull/3223#issuecomment-552679589

---

From: martinduke <[email-masked]>
Date: Tue, 12 Nov 2019 15:26:01 -0800

martinduke approved this pull request.

-- 
You are receiving this because you are subscribed to this thread.
Reply to this email directly or view it on GitHub:
https://github.com/quicwg/base-drafts/pull/3223#pullrequestreview-315913294

---

From: Jana Iyengar <[email-masked]>
Date: Tue, 19 Nov 2019 02:31:19 -0800

janaiyengar commented on this pull request.

Be consistent with "variation", or say that mean deviation is the same as variation. Otherwise, it's just confusing to someone who doesn't know that the two terms mean the same thing.

> @@ -251,8 +251,8 @@ RTT samples and peer-reported host delays (see Section 13.2 of
 {{QUIC-TRANSPORT}}) to generate a statistical description of the connection's
 RTT. An endpoint computes the following three values: the minimum value
 observed over the lifetime of the connection (min_rtt), an
-exponentially-weighted moving average (smoothed_rtt), and the variance in the
-observed RTT samples (rttvar).
+exponentially-weighted moving average (smoothed_rtt), and the mean deviation

```suggestion
exponentially-weighted moving average (smoothed_rtt), and the variation
```

> @@ -307,7 +307,8 @@ erroneously-reported delays by the peer.
 ## Estimating smoothed_rtt and rttvar {#smoothed-rtt}
 
 smoothed_rtt is an exponentially-weighted moving average of an endpoint's RTT
-samples, and rttvar is the endpoint's estimated variance in the RTT samples.
+samples, and rttvar is the endpoint's RTT mean deviation in the RTT samples,

```suggestion
samples, and rttvar is the variation in the RTT samples,
```

-- 
You are receiving this because you are subscribed to this thread.
Reply to this email directly or view it on GitHub:
https://github.com/quicwg/base-drafts/pull/3223#pullrequestreview-318930113

---

From: ianswett <[email-masked]>
Date: Tue, 19 Nov 2019 07:12:37 -0800

In both sentences, min_rtt and smoothed_rtt are described in technically accurate terms, so I think it makes sense to describe rttvar as a mean deviation, because that's the most technically accurate term.  I also understand the need for consistency, so if you have suggestions on how to improve that without removing the technical description, it'd be appreciated.

-- 
You are receiving this because you are subscribed to this thread.
Reply to this email directly or view it on GitHub:
https://github.com/quicwg/base-drafts/pull/3223#issuecomment-555551917